/* openssl_server.h 
 * written by Eric Rescorla, John Viega,
 * Matt Messier, Pravir Chandra,
 * and David Wilkinson, 09-14-03 */

#ifndef _openssl_server_h
#define _openssl_server_h
#endif

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>

#include <dns/types.h>
#include <dns/result.h>

#include <isc/string.h>
#include <isc/types.h>
#include <isc/stdio.h>
#include <isc/mem.h>
#include <isc/formatcheck.h>

#include "/usr/include/openssl/ssl.h"
#include "/usr/include/openssl/rsa.h"
#include "/usr/include/openssl/err.h"
#include "/usr/include/openssl/rand.h"
#include "/usr/include/openssl/bio.h"
#include "/usr/include/openssl/x509v3.h"

#define KEYFILE_SERVER "/usr/local/ssl/server.pem"
#define CIPHER_LIST_SERVER "ALL:!ADH:!LOW:!EXP:!MD5:@STRENGTH"

#ifndef PASSWORD_SERVER
#define PASSWORD_SERVER "hello1"
#endif

#ifndef RANDOM_SERVER
#define RANDOM_SERVER "/var/named/server_seed"
#endif

void generate_eph_rsa_key(SSL_CTX *ctx);
void init_dhparams(void);
DH *tmp_dh_callback(SSL *ssl, int is_export, int keylength);
SSL_CTX *initialize_server_ctx(void);
isc_result_t ssl_authenticate_client(void);

//#endif

