/* openssl_client.h 
 * written by Eric Rescorla,
 * John Viega, Matt Messier, Pravir
 * Chandra, and David Wilkinson, 09-14-03 */

#ifndef _openssl_client_h
#define _openssl_client_h
#endif

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>

#include <dns/request.h>
#include <dns/dispatch.h>

#include <isc/socket.h>
#include <isc/sockaddr.h>

#include "/usr/include/openssl/ssl.h"
#include "/usr/include/openssl/rsa.h"
#include "/usr/include/openssl/err.h"
#include "/usr/include/openssl/rand.h"
#include "/usr/include/openssl/bio.h"
#include "/usr/include/openssl/x509v3.h"

#define KEYFILE_CLIENT "/usr/local/ssl/client.pem"
#define CIPHER_LIST_CLIENT "ALL:!ADH:!LOW:!EXP:!MD5:@STRENGTH"

#ifndef PASSWORD_CLIENT
#define PASSWORD_CLIENT "hello2"
#endif

#ifndef RANDOM_CLIENT
#define RANDOM_CLIENT "/var/named/client_seed"
#endif

SSL_CTX *initialize_client_ctx(void);
void ssl_authenticate_server(dns_request_t *request);

//#endif

