/* openssl_common.h 
 * written by John Viega, Matt Messier,
 * Pravir Chandra, Eric Rescorla, and
 * David Wilkinson, 09-14-03
 */

#ifndef _openssl_common_h
#define _openssl_common_h

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include "/usr/include/openssl/ssl.h"
#include "/usr/include/openssl/rsa.h"
#include "/usr/include/openssl/err.h"
#include "/usr/include/openssl/rand.h"
#include "/usr/include/openssl/bio.h"
#include "/usr/include/openssl/x509v3.h"

#define CA_LIST "/usr/local/ssl/rootcert.pem"
//#define HOST "iris.artistslife.com"
#define PORT 5300
#define BUFSIZZ 1024

extern BIO *bio_err;
int berr_exit(char *string);
int err_exit(char *string);
void check_cert_chain(SSL *ssl, const char *host);
int verify_callback(int ok, X509_STORE_CTX *store);
SSL_CTX *initialize_ctx(char *keyfile, char *password);
void destroy_ctx(SSL_CTX *ctx);

#endif

